(*                               LE SOLITAIRE
                                 ============

Le jeu du solitaire est un jeu (de reflexion) qui se joue seul ;le but du jeu
est de ne rester qu'avec un seul pion sur l'chiquier ;chaque pion peut sauter
par dessus un autre pion  condition que la case d'arrive soit vide ;dans ce
cas le pion par dessus lequel on a saut disparat .Voici l'chiquier du jeu :
        +-----------+
         O  O  O          Cet chiquier peut se reprsenter en mmoire par
        +---+---+---         un tableau de 2 dimensions de 7 sur 7 ;il faut
         O  O  O          dj choisir un chiquier de 9 sur 9 ,pour pr-
+-------+---+---+---+-------+ voir une case supplmentaire sur les bords ,car
 O  O  O  O  O  O  O  si on saute vers l'xtrieur ,on peut tomber sur
+---+---+---+---+---+---+--- n'importe quoi ;par contre si on a rserv une
 O  O  O     O  O  O  case,on tombe sur cette case qui aura une valeur
+---+---+---+---+---+---+--- indiquant qu'on ne peut pas y sauter ;de cette
 O  O  O  O  O  O  O  faon on vite les plantages du programme .
+-------+---+---+---+-------+ Pour adapter facilement le programme en langage
         O  O  O          C, on commence le tableau  0 au lieu de 1,comme
        +---+---+---         on fait d'habitude en Pascal .
         O  O  O 
        +-----------+
Etudions en quelques lignes ce programme :
- c'est un exemple typique de backtracking
- on va avoir un chiquier de 9 sur 9 ,mais en une dimension ,donc un tableau
     linaire de 81 cases ;ceci est fait par souci de rapidit (voir plus bas
     le temps d'xcution)
- pour chaque pion (ou presque) on a quatre directions possibles pour sauter
- on peut sauter si la case jointe est occupe par un pion ET si la case sui-
     vante est vide
- une fois qu'on a jou un pion , on fait un appel recursif et on commence la
     recherche du prochain pion  jouer  partir de la premire case
- nous allons crer plusieurs procedures :
     - une pour l'initialisation de l'chiquier (procedure init_tab ;)
     - une pour l'affichage de l'chiquier (procedure aff_tab ;)
     - une fonction pour dterminer quel est le pion qui doit jouer
     - la procedure reprsentant le coeur du programme,la recursivit,le back-
          tracking

Nous allons tudier en dtail deux choses :
- la fonction pion_qui_doit_jouer :
     - cette fonction admet deux paramtres :
          - dernier_pion ,qui indique quel est le dernier pion qui a saut
          - last_dir , qui indique quelle est la dernire direction dans la-
              quelle le dernier pion a saut ;si le dernier pion peut sauter
              dans plusieurs directions et il ne les a pas toutes essayes ,
              alors il les essaie jusqu'au bout ,sinon un autre pion est
              choisi
     - pour dterminer quel pion doit jouer ,un balayage de l'chiquier a lieu
       et ce jusqu' le trouver ou jusqu' la fin de l'chiquier ,  savoir la
       case numro 68 dans le tableau ,qui correspond au dernier pion de
       l'chiquier pouvant sauter .
- la procedure "joue" ,qui reprsente le programme :
     - elle n'a pas de paramtres car il faut essayer d'viter de perdre du
          temps avec l'empilement et le dsempilement de variables pendant
          l'execution ,vu le nombre lev de possibilits
     - le point d'arrt est atteint quand on a fait 32 coups ,dans ce cas on
          initialise la variable "trouve"  true et ensuite on ne cherche plus
          d'autre solution ,mais on affiche les sauts et on sort.
     - on simule chaque coup par des remplissages du tableau avec des PION et
          avec des "VIDE" ,on rappelle la procedure ,et ensuite on annule le
          coup pour essayer une autre possibilit.

Ce programme a t xcut sur un PC 386  33 MHz.
Le temps d'xcution de ce programme est assez long : en Pascal ,pour trouver
la premire solution le programme met 1 heure et 21 minutes;en C il met seu-
lement 1 heure et 4 minutes ;ici aussi il y a plusieurs faons d'arriver au
rsultat ,  savoir un seul pion sur l'chiquier ,mais le programme est fait
pour s'arrter  la premire ;ds qu'il l'a trouve , il affiche le chemin en
sens inverse (l'chiquier se remplit progressivement , chaque appui sur une
touche ,au lieu de se vider) .

De plus ,ce temps a t amlior ,car on utilise ici un tableau en une dimen-
sion au lieu de 2 ;avec 2 dimensions ,et en langage C ,le programme mettait
6 heures et 5 minutes pour trouver la premire solution ;d'o le passage de
l'chiquier  une dimension .        *)


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Printers;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    Image2: TImage;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  chemin:string; {AVEC l'antislash final}

implementation

{$R *.DFM}


const INCONNU = 5 ;
      PION    = 3 ;
      VIDE    = 0 ;

      d  : array[0..3] of integer = (-9, 1, 9, -1) ;

type tab      = array[0..80] of byte ;
     tab_n    = array[1..32] of tab ;

var  t           : tab ;
     plateaux    : tab_n ;
     numero_coup : integer ;
     nb_coups    : longint ;
     trouve      : boolean ;

procedure init_tab ;
var x,y : integer ;
begin
for x:=0 to 8 do
for y:=0 to 8 do
    t[x*9+y]:=INCONNU ;
for y:=1 to 7 do
for x:=3 to 5 do
    begin
    t[y*9+x]:=PION ;
    t[x*9+y]:=PION ;
    end ;
t[4*9+4]:=VIDE;
end ;

procedure aff_tab(cnv:TCanvas;offx,offy,cote,n:integer);
var x,y  : integer ;
    code,oldcode,newcode: byte;
    diam : integer;
    i,j:integer;
    bon:boolean;
begin
    with cnv do
          begin
          for y:=0 to 8 do
              for x:=0 to 8 do
              begin
              //code:=T[y*9+x];
              code:=plateaux[n][y*9+x];
              //on ne dessine pas les cases qui contiennent INCONNU
              if code<>INCONNU then
                 begin
                 if n>=2 then oldcode:=plateaux[n-1][y*9+x];
                 if n<32 then newcode:=plateaux[n+1][y*9+x];
                 brush.style:=bsSolid;
                 brush.color:=clWhite;
                 pen.color:=clBlack;
                 rectangle(offx+x*cote,offy+y*cote,offx+x*cote+cote,offy+y*cote+cote);
                 if code=PION then
                    begin    
                    diam:=cote div 2;
                    brush.color:=clBlack;
                    pen.color:=clBlack;
                    if Form1.CheckBox3.Checked and (n>=2) then  //pion qui a jou -> ROUGE
                       if oldcode<>code then
                           begin
                           brush.color:=clRed;
                           pen.color:=clRed;
                           end;
                    if Form1.CheckBox4.Checked and (n<32) then  //pion qui va jouer -> VERT
                       if newcode<>code then
                           begin
                           //s'il n'est pas juste  ct d'une case qui est passe
                           //de VIDE  PION, c'est celui qui VA jouer
                           bon:=true;
                           for i:=-1 to 1 do
                               for j:=-1 to 1 do
                                   if (i<>0) or (j<>0) then
                                      if (plateaux[n][(y+j)*9+x+i]=VIDE)
                                      and (plateaux[n+1][(y+j)*9+x+i]=PION) then bon:=false;
                           if bon then
                              begin
                              brush.color:=clLime;
                              pen.color:=clLime;
                              end;
                           end;
                    ellipse(offx+x*cote+(cote-diam)div 2,offy+y*cote+(cote-diam)div 2,
                    diam+offx+x*cote+(cote-diam)div 2,diam+offy+y*cote+(cote-diam)div 2);
                    end;
                 end;
              end;
          Font.Name:='Arial';
          if cnv=Form1.Image2.Canvas then Font.Size:=round(12*Form1.Image2.Picture.Bitmap.Width/Form1.Image1.Picture.Bitmap.Width)
          else Font.Size:=12;
          brush.style:=bsClear;
          TextOut(offx,offy,inttostr(n));
          end;
end ;

//---- algorithme

function pion_qui_doit_jouer(dernier_pion : integer ;
    var last_dir : integer) : integer ;
var i,x,y,k1,k2 : integer ;
begin
x:=dernier_pion mod 10 -1 ;
y:=dernier_pion div 10 ;
while (y*10+x<78) do
   begin
   inc(x) ;
   if (x=8) then
      begin x:=0 ; inc(y) ;end ;
   for i:=last_dir to 3 do
       begin
       k1:=y*9+x ;k2:=d[i] ;
       if (T[k1]=PION) then
       if (T[k1+k2]=PION) then
       if (T[k1+2*k2]=VIDE) then
	  begin
          last_dir:=i ;
	  pion_qui_doit_jouer:=y*10+x ;
          exit ;
          end ;
       end ;
   last_dir:=0 ;
   end ;
pion_qui_doit_jouer:=0 ;
end ;

procedure print(cnv:TCanvas;n:integer);
var cote,x,y:integer;
begin
     if cnv=Printer.Canvas then cote:=(Printer.PageHeight div 8)div 9;
     if cnv=Form1.Image1.Canvas then cote:=(Form1.Image1.Height div 8)div 9;
     if cnv=Form1.Image2.Canvas then cote:=(Form1.Image2.Picture.Bitmap.Height div 8)div 9;
     x:=12*cote*((n-1) mod 4)+4*cote;
     y:=9*cote*((n-1) div 4)+cote;
     aff_tab(cnv,x,y,cote,n);
end;

procedure afficher_coup(numero_coup : integer) ;
begin
print(Form1.Image1.Canvas,numero_coup);   // l'cran
//Si on veut imprimer
if Form1.CheckBox1.Checked then print(Printer.Canvas,numero_coup);
//Si on veut en plus un beau fichier BMP pour l'imprimeur !
if Form1.CheckBox2.Checked then print(Form1.Image2.Canvas,numero_coup);
exit ;
end ;


procedure joue(numero_coup : integer ;var trouve : boolean) ;
var i,x,y,k1,k2,pion_qui_joue,dernier_pion_qui_a_joue,last_dir,k : integer ;
//    t1 : tab ;
begin
if (numero_coup=32) then
   begin
   //afficher_coup(32) ;
// c'est ici qu'on doit afficher tous les plateaux qui sont maintenant
// dans le tableau "plateaux"
   move(t,plateaux[numero_coup],sizeof(tab)) ;
   trouve:=true ;
   //Si on veut imprimer
   if Form1.CheckBox1.Checked then Printer.BeginDoc;
   for k:=1 to 32 do afficher_coup(k);
   //Si on veut imprimer
   if Form1.CheckBox1.Checked then Printer.EndDoc;

   exit ;
   end ;
last_dir:=0 ;
dernier_pion_qui_a_joue:=0 ;
inc(nb_coups) ;
if nb_coups mod 100000=0 then
   begin form1.edit1.text:=inttostr(nb_coups) ;form1.edit1.refresh ;end ;
repeat
   pion_qui_joue:=pion_qui_doit_jouer(dernier_pion_qui_a_joue,last_dir) ;
   dernier_pion_qui_a_joue:=pion_qui_joue ;
   if (dernier_pion_qui_a_joue>0) then
      begin
//      move(t,t1,sizeof(t)) ;
      move(t,plateaux[numero_coup],sizeof(tab)) ;
      i:=last_dir ;
      inc(last_dir) ;
      y:=pion_qui_joue div 10 ;
      x:=pion_qui_joue mod 10 ;
      k1:=y*9+x ;k2:=d[i] ;
      t[k1+2*k2]:=PION ;
      t[k1+k2]:=VIDE ;
      t[k1]:=VIDE ;
      joue(numero_coup+1,trouve) ;
//      move(t1,t,sizeof(t)) ;
      move(plateaux[numero_coup],t,sizeof(tab)) ;
// l'instruction suivante disparatra quand on dcidera de chercher toutes les solutions
      //if trouve then
      //   begin afficher_coup(numero_coup) ;exit ;end ;
      if trouve then exit;
      end ;
until (pion_qui_joue=0) ;
end ;

procedure TForm1.Button1Click(Sender: TObject);
var s:string;
begin
     //Si on veut en plus un beau fichier BMP pour l'imprimeur !
     if Form1.CheckBox2.Checked then
            begin
            Image2.Picture.Bitmap.Width:=Printer.PageWidth;
            Image2.Picture.Bitmap.Height:=Printer.PageHeight;
            end;

     Button1.Enabled:=false;
     init_tab ;
     nb_coups:=0 ;
     numero_coup:=1 ;
     trouve:=false ;
     Screen.Cursor:=crHourGlass;
     joue(numero_coup,trouve) ;
     Screen.Cursor:=crDefault ;
//     edit1.text:='ok' ;
     Button1.Enabled:=true;

     //Si on veut en plus un beau fichier BMP pour l'imprimeur !
     if Form1.CheckBox2.Checked then
        begin
        s:=Chemin+'Solitaire.bmp';
        Image2.Picture.SaveToFile(s);
        ShowMessage('Image enregistre sous ' + s);
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     chemin:=ExtractFilePath(Application.ExeName); {le chemin de l'appli, AVEC l'antislash final}
end;

end.
